#import "../../templates/template.typ": *

#show: project.with(
  title: "Type Annotations",
  subtitle: "Einführung in die Programmierung",
  logo: "unifreiburglogo.png",
  authors: (
    (name: "Nils Pukropp", email: "nils@narl.io", affiliation: "git.narl.io"),
  ),
)

= Vorwort

In dieser PDF werden alle wichtigen Grundlagen der Vorlesung #link("https://proglang.github.io/teaching.html", "Einführung in die Programmierung") zusammengefasst. Diese wurde für das WS2024/25 verfasst, andere Semester können Inhaltlich abweichen. Vor allem können neuere Python-Versionen zu anderen schreibweisen führen.

= Wie wird in Python programmiert? 

Um in Python zu Programmieren wird das Programm Python benötigt um den geschriebenen Quelltext zu interpretieren. Wie Python installiert wird ist von Semester zu Semester unterschiedlich (siehe #link("https://proglang.github.io/teaching/24ws/eidp/setup.html", "WS24/25")). Machen Sie sich mit Python vertraut, dazu gehört:

- Python-Dateien erstellen und ausführen
- Python-Shell im Terminal verwenden

Es gibt genügend Material online. Ich gehe hier trotzdem auf die beiden Modi ein, am Ende muss man aber einfach beim Üben sich mit den Tools vertraut machen. Dies kann man kaum textuell ohne Ausprobieren verstehen, gerade weil für viele wahrscheinlich das Terminal völlig neu ist.

== Python-Dateien erstellen

- Python wird in `*.py` Dateien geschrieben.
- Zum ausführen haben wir entweder das Programm `python3` im Terminal, oder einen "Run"-Knopf in unserer bevorzugten IDE (vscode, pycharm, ...)
- In die Python-Datei wird der Quelltext geschrieben, auf die Strukturen gehen wir später ein.
- Zum ausführen im Terminal wird der Kommand `python3 <name der python Datei>.py` benutzt

== Python-Shell

Eine Ausnahme dazu bietet die *Python-Shell*, diese ermöglicht das Zeile für Zeile schreiben von Python.

- Wenn wir `python3` ohne weitere Argumente im Terminal eingeben startet Python im interaktiven Modus.
- Wird signalisiert durch `>>>` im Terminal, hier können wir dann unseren Quelltext direkt schreiben und Zeile für Zeile direkt ausführen. Hier z.B. starten wir die Python-Shell. Das `$` signalisiert was in das Terminal auf Linux geschrieben wurde, alles danach ist die Python-Shell. Wir geben `print("Hello Python-Shell")` ein und bekommen auch direkt die Antwort `Hello Python-Shell`.

```python
$ python3
Python 3.13.1 (main, Dec  4 2024, 18:05:56) [GCC 14.2.1 20240910] on linux
Type "help", "copyright", "credits" or "license" for more information.
>>> print("Hello Python-Shell")
Hello Python-Shell
>>>
```

= Woraus besteht Python?

Python besteht aus *Keywords* und den bekannten arithmetischen Operatoren die wir aus der Mathematik kennen. Diese Keywords sind nicht einmal besonders viele, aber dadurch lassen sich fast alle Programme schreiben.

== Keywords in Python

=== Arithmetische Operatoren 

- Addition: `a + b`
- Subtraktion: `a - b`
- Multiplikation: `a * b`
- Division: `a / b`
- Modulo: `a % b`
- Ganzzahl Divison: `a // b`
- Potenzen: `a ** b`

=== Vergleich Operatoren

Neben den typischen arithmetischen Operatoren aus der Mathematik brauchen wir auch noch aussagenlogische Operatoren, um Werte und Zustände zu vergleichen und so den Programmfluss zu beschreiben.

- Äquivalenz ist etwas schwieriger, denn diese unterscheidet sich manchmal von Paradigmen zu Paradigmen. Aber für den Anfang sagen wir einfach wenn etwas gleich ist, dann ist es äquivalent: `a == b`
- Kleiner/Größer als: `a > b`, `a < b`
- Kleiner/Größer-Gleich als: `a >= b`, `a <= b`